# pylint: disable=missing-docstring

import requests
from ._tools import SaveLoad


class Rest(SaveLoad):
    '''
    '''

    def send_post(
        self,
        url: str,
        headers: dict = None,
        query: dict = None,
        cookies: dict = None,
        auth: tuple = None,
        exclude_none: bool = False,
        exclude_unset: bool = True,
        **kwargs
    ) -> SaveLoad | None:
        '''
        '''

        full_header = {
            'Accept': 'application/json',
            'Content-Type': 'application/json'
        }
        full_header.update(headers)

        resp = requests.post(
            url,
            data=self.dict(exclude_unset=exclude_unset, exclude_none=exclude_none),
            headers=full_header,
            params=query,
            cookies=cookies,
            auth=auth,
            **kwargs
        ).json()

        return resp

    @classmethod
    def load_get(
        cls,
        url: str,
        headers: dict = None,
        query: dict = None,
        cookies: dict = None,
        auth: tuple = None,
        **kwargs
    ) -> SaveLoad | None:
        '''
        '''

        full_header = {
            'Accept': 'application/json',
            'Content-Type': 'application/json'
        }
        full_header.update(headers)

        data = requests.get(
            url, headers=full_header, params=query, cookies=cookies, auth=auth, **kwargs
        ).json()
        cls._validate_schemas(data)

        return cls.parse_obj(data)

    @classmethod
    def load_post(
        cls,
        url: str,
        data: dict = None,
        headers: dict = None,
        query: dict = None,
        cookies: dict = None,
        auth: tuple = None,
        **kwargs
    ) -> SaveLoad | None:
        '''
        '''

        full_header = {
            'Accept': 'application/json',
            'Content-Type': 'application/json'
        }
        full_header.update(headers)

        data = requests.post(
            url, data=data, headers=full_header, params=query, cookies=cookies, auth=auth, **kwargs
        ).json()
        cls._validate_schemas(data)

        return cls.parse_obj(data)
